//============================================================================
// 635_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// Packet_Debug.h : header file
//
#if !defined(AFX_PACKET_DEBUG_H__5CB85332_DF93_4551_82E3_6C9AC4EBE1F3__INCLUDED_)
#define AFX_PACKET_DEBUG_H__5CB85332_DF93_4551_82E3_6C9AC4EBE1F3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// Packet_Debug dialog


#define SENT_STATUS_WAITING_TO_BE_SENT      0
#define SENT_STATUS_WAITING_FOR_ACKNOWLEDGE 1
#define SENT_STATUS_TIMED_OUT               2

typedef struct
  {
  // 0 = waiting to be sent
  // 1 = sent, waiting for acknowledge
  // 2 = timed out  
  // 3 = (command, will not happen)
  // 4 = acknowleged without error
  // 5 = (response, will not happen)
  // 6 = acknowledged with error
  int status;
  int timeout;
  COMMAND_PACKET packet;
  char user_text[1024];
  }HISTORY_ITEM;

#define SENT_HISTORY_LENGTH 150
#define RECEIVED_HISTORY_LENGTH 150

#define MAX_UNACKNOWLEDGED_PACKETS 1
#define ACKNOWLEDGE_TIMEOUT 30  //200ms

class Packet_Debug : public CDialog
{
CFont m_font;

// Construction
public:
  Packet_Debug(CWnd* pParent);   // standard constructor
  BOOL Create();
  virtual BOOL Packet_Debug::OnInitDialog();
  void Packet_Debug::Queue_Outgoing_Packet(COMMAND_PACKET *packet);
  void Packet_Debug::Timeout_No_Repsonse_Packets(void);
  void Packet_Debug::Record_Received_Packet(COMMAND_PACKET *packet);
  void Packet_Debug::RollAcknowledgeSpinner(void);
  void Packet_Debug::RollTemperatureSpinner(void);
  void Packet_Debug::RollFanSpinner(void);
  void Packet_Debug::RollKeySpinner(void);
  int Packet_Debug::Convert_Input_String_To_Array(const char *input,unsigned char *output);
  // Dialog Data
  //{{AFX_DATA(Packet_Debug)
  enum { IDD = IDD_Packet_Debugger_Dialog };
  CButton m_show_ascii_output;
  CButton m_show_hex_output;
  CButton m_show_keys;
  CEdit m_key_spinner;
  CEdit m_acknowledge_spinner;
  CEdit m_fan_spinner;
  CEdit m_temp_spinner;
  CButton m_show_temperatures;
  CButton m_show_fans;
  CButton m_show_acknowledges;
  CComboBox m_command;
  CEdit m_input;
  CEdit m_data_length;
  CEdit m_received;
  CEdit m_sent;
  //}}AFX_DATA


// Overrides
  // ClassWizard generated virtual function overrides
  //{{AFX_VIRTUAL(Packet_Debug)
  protected:
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
  virtual void PostNcDestroy();
//}}AFX_VIRTUAL

// Implementation
protected:
  CWnd* m_pParent;
  int m_nID;

  void Packet_Debug::Show_Received_Packets(void);
  void Packet_Debug::Show_Sent_Packets(void);
  void Packet_Debug::Send_Queued_Packets(void);
  void Packet_Debug::Set_Sent_User_Text(HISTORY_ITEM *history);
  void Packet_Debug::Set_Received_User_Text(char *user_text,COMMAND_PACKET *packet);
  void Packet_Debug::Reconcile_Acknowledge(COMMAND_PACKET *packet);

  unsigned char acknowledge_spinner_state;
  unsigned char temperature_spinner_state;
  unsigned char fan_spinner_state;
  unsigned char key_spinner_state;

  HISTORY_ITEM sent_history[SENT_HISTORY_LENGTH];
  int sent_history_head;
  int sent_history_tail;
  HISTORY_ITEM received_history[RECEIVED_HISTORY_LENGTH];
  int received_history_head;
  int received_history_tail;

  // Generated message map functions
  //{{AFX_MSG(Packet_Debug)
  afx_msg void OnClose();
  afx_msg void OnSendPacket();
  afx_msg void OnChangeInput();
  afx_msg void OnSetfocusInput();
  afx_msg void OnUpdateInput();
  afx_msg void OnKillfocusInput();
  afx_msg void OnShowFans();
  afx_msg void OnShowTemperatures();
  afx_msg void OnShowAcknowledges();
  afx_msg void OnShowKeys();
  afx_msg void OnShowHexOutput();
  afx_msg void OnShowAsciiOutput();
  afx_msg void OnClearHistories();
  //}}AFX_MSG
  DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PACKET_DEBUG_H__5CB85332_DF93_4551_82E3_6C9AC4EBE1F3__INCLUDED_)
